import json
import urllib2
import re
import os
from twisted.web.client import getPage
URL = "http://ip-api.com/json"


def get_ip_info(tun=False):
	infos = []
	try:
		content = get_ip_info_data()
		if content:
			ip = content["query"].encode("utf-8") if isinstance(content["query"], unicode) else str(content["query"])
			if tun:
				ip = get_ping(ip)
			else:
				ip = "IP: " + ip if ip else "IP: n/a"
			infos.append(ip)
			country = "Country: " + content["country"].encode("utf-8") if isinstance(content["country"], unicode) else "Country: " + content["country"]
			infos.append(country)
			region = "Region: " + content["regionName"].encode("utf-8") if isinstance(content["regionName"], unicode) else "Region: " + content["regionName"]
			infos.append(region)
			city = "City: " + content["city"].encode("utf-8") if isinstance(content["city"], unicode) else "City: " + content["city"]
			infos.append(city)
			org = "Organisation: " + content["org"].encode("utf-8") if isinstance(content["org"], unicode) else "Organisation: " + content["org"]
			infos.append(org)
		else:
			infos = ["IP: n/a", "Country: n/a", "Region: n/a", "City: n/a", "Organisation: n/a"]
	except:
		infos = ["IP: n/a", "Country: n/a", "Region: n/a", "City: n/a", "Organisation: n/a"]

	info_label = ""
	if infos:
		for i in infos:
			info_label = info_label + i + "\n"
	return info_label


def get_ping(ip):
	ping = "IP: n/a\nPing: n/a"
	if ip:
		try:
			read_proc = os.system("ping -c 2 " + ip)
			proc_data = read_proc.read()
			read_proc.close()
			result = re.findall("round-trip min/avg/max = \d+\\.\d+/(\d+\\.\d+)/\d+\\.\d+\sms", proc_data, re.S)
			if result:
				ping = "IP: %s\nPing: %s ms" % (ip, result[0])
		except OSError:
			ping = "IP: %s\n" % ip
	return ping

def get_ip_info_data():
	content = None
	try:
		url = urllib2.urlopen(URL, timeout=4)
		print "=====> Url",url
		content = json.load(url)
	except:
		pass
	return content
